var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import React from 'react';
import { Modal as RCTModal, TouchableWithoutFeedback, View } from 'react-native';
import { useTheme } from '../Hooks/Theme';
export const Modal = (props) => {
    const { children, onBackgroundPress, theme, subtle } = props, others = __rest(props, ["children", "onBackgroundPress", "theme", "subtle"]);
    const config = useTheme(theme);
    const color = subtle ? config.color.subtle['primary'] : config.color.main['primary'];
    return (React.createElement(RCTModal, Object.assign({}, others),
        React.createElement(TouchableWithoutFeedback, { onPress: onBackgroundPress },
            React.createElement(View, { style: {
                    position: 'absolute',
                    top: 0,
                    bottom: 0,
                    left: 0,
                    right: 0,
                    backgroundColor: 'rgba(0, 0, 0, 0.5)',
                    justifyContent: 'center',
                    alignContent: 'center',
                    alignItems: 'center',
                } },
                React.createElement(View, { style: [
                        config.spacing.modal,
                        config.border.modal,
                        {
                            backgroundColor: color.background,
                            borderColor: color.border,
                            shadowColor: color.shadow,
                            width: '90%'
                        }
                    ] }, children)))));
};
